#include "MOD_RS485_ISO.h"
#include "Arduino.h"

C_MOD_RS485_ISO::C_MOD_RS485_ISO()
{
	company = OLIMEX_ID;
	device = MOD_RS485_ISO;
	strcpy(DEVICE_NAME, "MOD-RS485-ISO");
}
void C_MOD_RS485_ISO::PrintName(void)
{
	Serial.write("\f");
	Serial.write(DEVICE_NAME);
	Serial.println("");
	Serial.println("");
}
void C_MOD_RS485_ISO::PrintHelp(void)
{
	Serial.println ("");
	Serial.println ("Commands:");
	Serial.println ("--------------------------------------------------");
	Serial.println ("SCAN \t\t\tPerform scan for installed devices");
	Serial.println ("NEW ADDRESS \t\tSend address to new device");
	Serial.println ("CLC\t\t\tOpen or close CLCs");
	

}
void C_MOD_RS485_ISO::ScanForInstalledDevices(void)
{
	
	unsigned char count = 0;
	unsigned char ack, addr[2];
	char buffer[10], j;

	Serial.println("");
	Serial.print("FROM >");
	ReadCommand(buffer);
	addr[0] = StringToInt(buffer);

	Serial.println("");
	Serial.print("TO >");
	ReadCommand(buffer);
	addr[1] = StringToInt(buffer);


	Serial.println("");
	Serial.write("Num");
	Serial.write("\t");
	Serial.write("\t");
	Serial.write("Comapny");
	Serial.write("\t");
	Serial.write("\t");
	Serial.write("Device");
	Serial.write("\t");
	Serial.write("\t");
	Serial.println("Address");
	Serial.println("------------------------------------------------------------");
	


	for(int i = addr[0]; i <= addr[1]; i++)
	{
		ack = ScanAddress(i);
		if(!ack) 
		{
			count++;
			Serial.print(count, DEC);
			Serial.write("\t");
			Serial.write("\t");
			Serial.print("OLIMEX");
			Serial.write("\t");
			Serial.write("\t");
			Serial.print("MOD-RS485-ISO");
			Serial.write("\t");
			Serial.write("\t");
			Serial.write("0x");
			Serial.print(i, HEX);
			Serial.println("");
		}
	}
	
	
	Serial.println("");
	Serial.print("DEVICES FOUND: ");
	Serial.println(count, DEC);
	Serial.println ("");

}
void C_MOD_RS485_ISO::StartSystem(void)
{
	char buffer[20], ch;
	Serial.println("");
	Serial.print ("Command > ");
	ReadCommand(buffer);

	Serial.println("");
	if(!strcmp(buffer, "scan") || !strcmp(buffer, "SCAN"))
		ch = 1;
	else if(!strcmp(buffer, "new address") || !strcmp(buffer, "NEW ADDRESS"))
		ch = 2;
	else if(!strcmp(buffer, "clc") || !strcmp(buffer, "CLC"))
		ch = 3;
	else if(!strcmp(buffer, "help") || !strcmp(buffer, "HELP"))
		ch = 9;
	else
		ch = 0;


	switch(ch)
  {
    case 1:  ScanForInstalledDevices(); break;
    case 2:  SetAddress(); break;
	case 3:  SetCLC(); break;

    
    case 9:	 PrintHelp(); break;
    case 0:   Serial.println ("No such command"); break;
  }   
		
}
void C_MOD_RS485_ISO::SetCLC(void)
{
	unsigned char data, addr;
	char buffer[10], ack, buffer2[10];


	Serial.print("DEVICE >");	
	ReadCommand(buffer);
	addr = StringToInt(buffer);	
	Serial.println("");

	Serial.print("SET VALUE >");
	ReadCommand(buffer2);
	data = StringToInt(buffer2);
	Serial.println("");
	
		
	StartI2C();
	WriteByteI2C(company);
	WriteByteI2C(device);
	WriteByteI2C(addr);
	WriteByteI2C(0x30);
	ack = WriteByteI2C(data);
	StopI2C();
			

	if(!ack)
		Serial.println("DONE.");
	else
		Serial.println("ERROR!");	

		
}
